import java.awt.BorderLayout;
import java.awt.Font;
import java.io.*;
import java.net.*;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.Date;
import java.sql.*;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.hackystat.sensorbase.client.SensorBaseClient;
import org.hackystat.sensorbase.client.SensorBaseClientException;
import org.hackystat.sensorbase.resource.sensordatatypes.jaxb.SensorDataType;
import org.hackystat.sensorbase.resource.sensordatatypes.jaxb.SensorDataTypeIndex;
import org.hackystat.sensorbase.resource.sensordatatypes.jaxb.SensorDataTypeRef;
import javax.xml.datatype.XMLGregorianCalendar;
import org.hackystat.utilities.tstamp.Tstamp;
import org.hackystat.sensorbase.resource.sensordata.jaxb.*;
import org.hackystat.sensorbase.resource.users.jaxb.*;
import org.hackystat.sensorbase.resource.users.jaxb.User;
import org.hackystat.sensorbase.resource.users.UserManager;
import org.hackystat.sensorbase.resource.sensorbase.SensorBaseResource;

import static org.hackystat.sensorbase.server.ServerProperties.ADMIN_EMAIL_KEY;
import static org.hackystat.sensorbase.server.ServerProperties.HOSTNAME_KEY;

import org.hackystat.sensorbase.mailer.Mailer;

import org.hackystat.utilities.email.ValidateEmailSyntax;
import org.restlet.Context;
import org.restlet.data.Form;
import org.restlet.data.MediaType;
import org.restlet.data.Request;
import org.restlet.data.Response;
import org.restlet.data.Status;
import org.restlet.resource.Representation;
import org.restlet.resource.StringRepresentation;
import org.restlet.resource.Variant;


/*ATENDENTE DA CONEXO_GERAL (MAIN) DO PROJETO MODUS-SD - SERVIDOR*/
/*Author: Gregory Wanderley*/
public class Atendente implements Runnable {

	private Socket s;
	private int k;
	private String login_R;
	private String login_geral;
	private String Data_Inicial, Data_Final, Hora_Inicial, Hora_Final;
	/**
	 * @param args
	 */
	
	public Atendente ( Socket s )
    {
       this.s = s;
    }
	
public int Login(Socket socket){ // LOGIN
		
		Connection conn = null;
		Connection conn1 = null;
		String teste = "SELECT login, senha FROM dados;";
		
		   int chave = 0;
		  
		   int conte = 0;
		   
		   
		   try {
			 //  while(true){
			 
			System.out.println("Conexao Realizada");
			
            
         // OBTEM O CANAL DE SAIDA PARA O SOCKET QUE SE COMUNICA COM O CLIENTE
    	    OutputStream tx = socket.getOutputStream( );
    	    DataOutputStream canalSaida = new DataOutputStream ( tx );
    	    
    	    // OBTEM O CANAL DE ENTRADA PARA O SOCKET QUE SE COMUNICA COM O CLIENTE
    	    InputStream rx = socket.getInputStream( );
    	    DataInputStream canalEntrada = new DataInputStream ( rx );
            
    	    k = 0;
            
    	    
    	    
            try {
            	 
                Class.forName("com.mysql.jdbc.Driver");
               // System.out.println("1 - OK");
                conn = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
                
                
                    String Login_R = canalEntrada.readUTF(); // recebe o login do cliente
                    String Senha_R = canalEntrada.readUTF(); // recebe a senha do cliente
                    
                  // banco de dados com nome e senha dos usuarios que conectam no socket
                    System.out.println("Login Recebido: "+Login_R+" senha recebida: "+Senha_R);
                
                
                Statement stm = conn.createStatement();  // para o banco dos users sockets
                ResultSet rs = stm.executeQuery(teste); // banco users sockets
                
                while (rs.next()) {
                    String nome = rs.getString("Login");
                    String senha = rs.getString("Senha");
                   
                    System.out.println("Nome: " + nome + " Senha: " + senha);
                    
                   if(nome.equals(Login_R)){
                       chave = 1;
                    if((chave == 1) && (senha.equals(Senha_R))){
                    	login_geral = nome;
                    	System.out.println("LOGIN GERAL: "+login_geral);
                    	chave = 2;
                       	break;
                       }
                    }
                } // while
                
                canalSaida.writeInt(chave);
                if(chave == 2){
                	System.out.println("Usuario logado com sucesso");
                	chave = 0;
                	k = 1;
                	
                	// pegar a data e hora inicial (usurio logado)
                	
                	    SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
            	        System.out.println(sdf.format(new Date()));
                        Data_Inicial = sdf.format(new Date()); // string pega
                        

                        SimpleDateFormat sdf_1 = new SimpleDateFormat("HH:mm:ss");
            	        System.out.println(sdf_1.format(new Date()));
                        Hora_Inicial = sdf_1.format(new Date()); // string pega
                        
                	
               }else{
                	if(chave == 0){
                		System.out.println("Usuario inexistente");
                	    chave = 0;
                	    k = 0;
                	}else{
                		if(chave == 1){
                			System.out.println("Senha invalida");
                		    chave = 0;
                		    k = 0;
                		}
                	}
                }
                 
               
            } catch(ClassNotFoundException e) {
                System.out.println("excesso Classe no encontrada");
                e.printStackTrace();
            } catch(SQLException e) {
                System.out.println("SQL Exception... Erro na consulta:");
                e.printStackTrace();
            } finally {
                try {
                    conn.close();
                    System.out.println("\n\nFechamendo a conexo");
                } catch(SQLException erro) {
                    System.out.println("Erro no fechamento");
                    erro.printStackTrace();
                }
            }
            
           
		 } 
	catch ( Exception e ) { 
		System.out.println( e );
		System.out.println ( "Servidor terminando ..." );
	}
	
	return k;
	
  } // fim da funo Login
	
	
	
	
	
			// codigo executado pela thread
		   
	      public void run( )
	      {
	         try
	         {
	         // descobrindo o IP e a porta do cliente
	         
	            InetAddress IPCliente = s.getInetAddress( );
	         
	            int portaCliente = s.getPort( );
	            int opcao_escolhida, botao_sair;
	            
	            botao_sair = 0;
	            System.out.println( "Identificacao do cliente:" );
	            System.out.println( IPCliente );
	            System.out.println( portaCliente );
	         
	            
	            
	        	// fazer um switch (dentro de um while) com um "opcao"/"chame" para escolher qual a funo 
	            // escolhida no cliente	
	        		
	            // OBTEM O CANAL DE SAIDA PARA O SOCKET QUE SE COMUNICA COM O CLIENTE
	    	    OutputStream tx = s.getOutputStream( );
	    	    DataOutputStream canalSaida = new DataOutputStream ( tx );
	    	    
	    	    // OBTEM O CANAL DE ENTRADA PARA O SOCKET QUE SE COMUNICA COM O CLIENTE
	    	    InputStream rx = s.getInputStream( );
	    	    DataInputStream canalEntrada = new DataInputStream ( rx );
	            
	    	  
	            
	        	while(true){
	        		// recebe a opo do cliente
	        		opcao_escolhida = canalEntrada.readInt();
	        		
	        		switch(opcao_escolhida){ // Opes
	        		
	        		
	        		case 2: // login
	        		int z =	Login(s); //  chama a funo para verificar o Login
	        		      
	    	            System.out.println("PASSOU PELO LOGIN");
	        			
	    	            if(z == 1){ // passou pelo login,
	    	            	
	    	            	
	    	            	// enviar tipo de usurio
		    	            
	    	            	Connection connx2 = null;
	            			String testex2 = "SELECT tipo_GER_PROJ, tipo_ANA, tipo_DESG, tipo_PROG, tipo_TEST FROM dados WHERE login = '"+login_geral+"';";
	            			
	            			
	            			
	            			try {
	                        	
	                            Class.forName("com.mysql.jdbc.Driver");
	                          
	                            connx2 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	                            
	                            
	                             
	                            Statement stmx2 = connx2.createStatement();  // para o banco dos users sockets
	                            ResultSet rsx2 = stmx2.executeQuery(testex2); // banco users sockets
	                            
	                            
	                           
	                            String tipo_GER_PROJ = new String();
	                            String tipo_ANA_SIS = new String();
	                            String tipo_DESG = new String();
	                            String tipo_PROG = new String();
	                            String tipo_TEST = new String();
	                            
	                            while (rsx2.next()) {
	                                
	                            	tipo_GER_PROJ = rsx2.getString("tipo_GER_PROJ");
	                            	tipo_ANA_SIS = rsx2.getString("tipo_ANA");
	                            	tipo_DESG = rsx2.getString("tipo_DESG");
	                            	tipo_PROG = rsx2.getString("tipo_PROG");
	                            	tipo_TEST = rsx2.getString("tipo_TEST");
	                            
	                            } // while
	            			
	                            
	                            
	                            // envia para o atualiza cadastro os dados
	                            
	                            canalSaida.writeUTF(tipo_GER_PROJ);
	                            canalSaida.writeUTF(tipo_ANA_SIS);
	                            canalSaida.writeUTF(tipo_DESG);
	                            canalSaida.writeUTF(tipo_PROG);
	                            canalSaida.writeUTF(tipo_TEST);
	                            
	                            
	                            
	            			 } catch(ClassNotFoundException e) {
	            	                System.out.println("excesso Classe no encontrada");
	            	                e.printStackTrace();
	            	            } catch(SQLException e) {
	            	                System.out.println("SQL Exception... Erro na consulta:");
	            	                e.printStackTrace();
	            	            } finally {
	            	                try {
	            	                    connx2.close();
	            	                    System.out.println("\n\nFechamendo a conexo");
	            	                } catch(SQLException erro) {
	            	                    System.out.println("Erro no fechamento");
	            	                    erro.printStackTrace();
	            	                }
	            	            }
	    	            	
	    	            	
	    	            	
	    	            	
	    	            	
	    	            	
	    	            	
	    	            	
	    	            	
	    	            	while(true){ // entrou automaticamente no opes
	    	            		
	    	            		int sub_opcao = canalEntrada.readInt();
	    	            		
	    	            		if(sub_opcao == 12){ //  entrou no atualiza cadastro inicializao dos campos
	    	            			
	    	            			// pega os dados da base de dados
	    	            			
	    	            			
	    	            			int opx = canalEntrada.readInt();
	    	            			
	    	            			String log_new = new String();
	    	            			if(opx == 1278){ // gerente
	    	            				
	    	            				String Pass1 = new String();
	    	            				Connection connx = null;
		    	            			String teste6 = "SELECT COUNT(*) FROM dados;";
		    	            			
		    	            			System.out.println("COUNTTT ");
		    	            			try{
		    	            			Class.forName("com.mysql.jdbc.Driver");
		    	                          
	    	                            connx = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	    	                            
	    	                            
	    	                             
	    	                            Statement stm = connx.createStatement();  // para o banco dos users sockets
	    	                            int  cont_aux = 0;
	    	                               
	    	                            ResultSet rs = stm.executeQuery(teste6);  
	    	                            if (!rs.next())  
	    	                            throw new SQLException("erro ao ler o tipo do curso: ");  
	    	                            
	    	                            System.out.println(rs.getInt("count(*)"));  
	    	                            int qtde_nomes = rs.getInt("count(*)");
	    	                            canalSaida.writeInt(qtde_nomes); 
	    	                            
	    	                           String teste7 = "SELECT login from dados;";
	    	                            Statement stm1 = connx.createStatement();
	    	                            ResultSet rs1 = stm.executeQuery(teste7);  
	    	                            String nomes = new String();
	    	                            while(rs1.next()){
	    	                            	canalSaida.writeUTF(rs1.getString("login"));
	    	                            	
	    	                            	cont_aux++;
	    	                            }
	    	                            System.out.println("Cont_Aux = "+cont_aux);
	    	                            
		    	            			} catch(ClassNotFoundException e) {
	    	            	                System.out.println("excesso Classe no encontrada");
	    	            	                e.printStackTrace();
	    	            	            } catch(SQLException e) {
	    	            	                System.out.println("SQL Exception... Erro na consulta:");
	    	            	                e.printStackTrace();
	    	            	            } finally {
	    	            	                try {
	    	            	                    connx.close();
	    	            	                    System.out.println("\n\nFechamendo a conexo");
	    	            	                } catch(SQLException erro) {
	    	            	                    System.out.println("Erro no fechamento");
	    	            	                    erro.printStackTrace();
	    	            	                }
	    	            	            }
	    	            				
	    	            				int opx2 = canalEntrada.readInt();
	    	            				
	    	            				if(opx2 == 1000){ // ok, mostrar campos do login
	    	            				// receber login
	    	            					
	    	            					String logx = canalEntrada.readUTF();
	    	            					log_new = logx;
	    	            					String Atualiza_Senha = new String();
	    	            					System.out.println("log_new = "+log_new);
	    	            					Connection conn = null;
	    	    	            			String teste = "SELECT  senha, nome, formacao, habilidades, interesses, cursos_realizados, tipo_GER_PROJ, email, tipo_ANA, tipo_DESG, tipo_PROG, tipo_TEST FROM dados WHERE login = '"+logx+"';";
	    	    	            			
	    	    	            			
	    	    	            			
	    	    	            			try {
	    	    	                        	
	    	    	                            Class.forName("com.mysql.jdbc.Driver");
	    	    	                          
	    	    	                            conn = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	    	    	                            
	    	    	                            
	    	    	                             
	    	    	                            Statement stm = conn.createStatement();  // para o banco dos users sockets
	    	    	                            ResultSet rs = stm.executeQuery(teste); // banco users sockets
	    	    	                            
	    	    	                            
	    	    	                            String senha = new String();
	    	    	                            String nome = new String();
	    	    	                            String formacao = new String();
	    	    	                            String habilidades = new String();
	    	    	                            String interesses = new String();
	    	    	                            String cursos_realizados = new String();
	    	    	                            String tipo_GER_PROJ = new String();
	    	    	                            String email = new String();
	    	    	                            String tipo_ANA_SIS = new String();
	    	    	                            String tipo_DESG = new String();
	    	    	                            String tipo_PROG = new String();
	    	    	                            String tipo_TEST = new String();
	    	    	                            
	    	    	                            while (rs.next()) {
	    	    	                                
	    	    	                            	senha = rs.getString("senha");
	    	    	                            	nome = rs.getString("nome");
	    	    	                            	formacao = rs.getString("formacao");
	    	    	                                habilidades = rs.getString("habilidades");
	    	    	                            	interesses = rs.getString("interesses");
	    	    	                            	cursos_realizados = rs.getString("cursos_realizados");
	    	    	                            	tipo_GER_PROJ = rs.getString("tipo_GER_PROJ");
	    	    	                            	email = rs.getString("email");
	    	    	                            	tipo_ANA_SIS = rs.getString("tipo_ANA");
	    	    	                            	tipo_DESG = rs.getString("tipo_DESG");
	    	    	                            	tipo_PROG = rs.getString("tipo_PROG");
	    	    	                            	tipo_TEST = rs.getString("tipo_TEST");
	    	    	                            
	    	    	                            } // while
	    	    	            			
	    	    	                            System.out.println("HABILIDADES: "+habilidades);
	    	    	                            System.out.println("INTERESSES: "+interesses);
	    	    	                            System.out.println("CURSOSREALIZADOSS: "+cursos_realizados);
	    	    	                            
	    	    	                            
	    	    	                            
	    	    	                            // envia para o atualiza cadastro os dados
	    	    	                            canalSaida.writeUTF(senha);
	    	    	                            Pass1 = senha;
	    	    	                            canalSaida.writeUTF(nome);
	    	    	                            canalSaida.writeUTF(formacao);
	    	    	                            canalSaida.writeUTF(habilidades);
	    	    	                            canalSaida.writeUTF(interesses);
	    	    	                            canalSaida.writeUTF(cursos_realizados);
	    	    	                            canalSaida.writeUTF(tipo_GER_PROJ);
	    	    	                            canalSaida.writeUTF(email);
	    	    	                            canalSaida.writeUTF(tipo_ANA_SIS);
	    	    	                            canalSaida.writeUTF(tipo_DESG);
	    	    	                            canalSaida.writeUTF(tipo_PROG);
	    	    	                            canalSaida.writeUTF(tipo_TEST);
	    	    	                            
	    	    	                            
	    	    	                            
	    	    	            			 } catch(ClassNotFoundException e) {
	    	    	            	                System.out.println("excesso Classe no encontrada");
	    	    	            	                e.printStackTrace();
	    	    	            	            } catch(SQLException e) {
	    	    	            	                System.out.println("SQL Exception... Erro na consulta:");
	    	    	            	                e.printStackTrace();
	    	    	            	            } finally {
	    	    	            	                try {
	    	    	            	                    conn.close();
	    	    	            	                    System.out.println("\n\nFechamendo a conexo");
	    	    	            	                } catch(SQLException erro) {
	    	    	            	                    System.out.println("Erro no fechamento");
	    	    	            	                    erro.printStackTrace();
	    	    	            	                }
	    	    	            	            }
	    	    	            			 
	    	    	            			
	    	    	            			
	    	    	            			// fazer igual no cadastro (mesmas funes)
	    	    	            			
	    	    	            			
	    	    	            	            while(true){ // funes internas do atualiza
	    	    	            	            	int sub_opcao_2 = canalEntrada.readInt();
	    	    	            	            	
	    	    	            	            	if(sub_opcao_2 == 121){ // salvar e sair
	    	    	            	            	
	    	    	            	            		//l campos e armazena no DATABASE
	    	    	        	        				
	    	    	        	        			    Atualiza_Senha = canalEntrada.readUTF();
	    	    	        	        				// gravar na base de dados a nova senha do hackystat
	    	    	        	        				String Atualiza_Nome = canalEntrada.readUTF();
	    	    	        	        				String Atualiza_Formacao = canalEntrada.readUTF();
	    	    	        	        		     	String Atualiza_Email = canalEntrada.readUTF();
	    	    	        	        			    String Tipo_GER_PROJ = canalEntrada.readUTF();
	    	    	        	        				String Tipo_ANA_SIS = canalEntrada.readUTF();
	    	    	        	        				String Tipo_DESG = canalEntrada.readUTF();
	    	    	        	        				String Tipo_PROG = canalEntrada.readUTF();
	    	    	        	        				String Tipo_TEST = canalEntrada.readUTF();
	    	    	        	        				String Atualiza_Habilidades = canalEntrada.readUTF();
	    	    	        	        				String Atualiza_Interesses = canalEntrada.readUTF();
	    	    	        	        				String Atualiza_Cursos_Realizados = canalEntrada.readUTF();
	    	    	        	        				 
	    	    	        	        				
	    	    	        	        				      Class.forName("com.mysql.jdbc.Driver");
	    	    	        		       	                  // System.out.println("1 - OK");
	    	    	        		       	    	          Connection conn1 = null;
	    	    	        		       	                  conn1 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	    	    	        		       	                  Statement stm1 = conn1.createStatement();  // para o banco dos users sockets
	    	    	        	        				
	    	    	        		       	               System.out.println("PASSOUUUUUUUUUUUU");
	    	    	        	        				String teste1 = "UPDATE dados SET senha = '"+Atualiza_Senha+"', nome = '"+Atualiza_Nome+"', formacao = '"+Atualiza_Formacao+"', habilidades = '"+Atualiza_Habilidades+"', interesses = '"+Atualiza_Interesses+"', cursos_realizados = '"+Atualiza_Cursos_Realizados+"', email = '"+Atualiza_Email+"', tipo_GER_PROJ = '"+Tipo_GER_PROJ+"', tipo_ANA = '"+Tipo_ANA_SIS+"', tipo_DESG = '"+Tipo_DESG+"', tipo_PROG = '"+Tipo_PROG+"', tipo_TEST = '"+Tipo_TEST+"' WHERE login = '"+log_new+"';";
	    	    	        	        				stm1.executeUpdate(teste1);
	    	    	        	        				
	    	    	        	        				System.out.println("PASSOU1111111111");
	    	    	        	        				
	    	    	        	        				Connection connb = null;
	    	    		    	            			String testeb = "SELECT  senha FROM dados WHERE login = '"+log_new+"';";
	    	    		    	            			
	    	    		    	            			

	    	    		    	            			     break;
	    	    	            	            	}
	    	    		    	            			
	    	    	            	            
	    	    	            	            	
	    	    	            	            	if(sub_opcao_2 == 122){ // cancelar
	    	    	            	            		break;
	    	    	            	            	}
	    	    	            	            	
	    	    	            	            	
	    	    	            	            } // fim do while true
	    	            					
	    	            					
	    	            				} // fim do if 1000
	    	            				
	    	            				if(opx2 == 122){} // cancelar
	    	            				
	    	            			}else{
	    	            			
	    	            			// receber de quem  o login para pegar os dados dele
	    	            			 login_R = canalEntrada.readUTF();
	    	            			
	    	            			Connection conn = null;
	    	            			String teste = "SELECT  senha, nome, formacao, habilidades, interesses, cursos_realizados, tipo_GER_PROJ, email, tipo_ANA, tipo_DESG, tipo_PROG, tipo_TEST FROM dados WHERE login = '"+login_R+"';";
	    	            			
	    	            			
	    	            			
	    	            			try {
	    	                        	
	    	                            Class.forName("com.mysql.jdbc.Driver");
	    	                          
	    	                            conn = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	    	                            
	    	                            
	    	                             
	    	                            Statement stm = conn.createStatement();  // para o banco dos users sockets
	    	                            ResultSet rs = stm.executeQuery(teste); // banco users sockets
	    	                            
	    	                            
	    	                            String senha = new String();
	    	                            String nome = new String();
	    	                            String formacao = new String();
	    	                            String habilidades = new String();
	    	                            String interesses = new String();
	    	                            String cursos_realizados = new String();
	    	                            String tipo_GER_PROJ = new String();
	    	                            String email = new String();
	    	                            String tipo_ANA_SIS = new String();
	    	                            String tipo_DESG = new String();
	    	                            String tipo_PROG = new String();
	    	                            String tipo_TEST = new String();
	    	                            
	    	                            while (rs.next()) {
	    	                                
	    	                            	senha = rs.getString("senha");
	    	                            	nome = rs.getString("nome");
	    	                            	formacao = rs.getString("formacao");
	    	                                habilidades = rs.getString("habilidades");
	    	                            	interesses = rs.getString("interesses");
	    	                            	cursos_realizados = rs.getString("cursos_realizados");
	    	                            	tipo_GER_PROJ = rs.getString("tipo_GER_PROJ");
	    	                            	email = rs.getString("email");
	    	                            	tipo_ANA_SIS = rs.getString("tipo_ANA");
	    	                            	tipo_DESG = rs.getString("tipo_DESG");
	    	                            	tipo_PROG = rs.getString("tipo_PROG");
	    	                            	tipo_TEST = rs.getString("tipo_TEST");
	    	                            
	    	                            } // while
	    	            			
	    	                            System.out.println("HABILIDADES: "+habilidades);
	    	                            System.out.println("INTERESSES: "+interesses);
	    	                            System.out.println("CURSOSREALIZADOSS: "+cursos_realizados);
	    	                            
	    	                            
	    	                            
	    	                            // envia para o atualiza cadastro os dados
	    	                            canalSaida.writeUTF(senha);
	    	                            canalSaida.writeUTF(nome);
	    	                            canalSaida.writeUTF(formacao);
	    	                            canalSaida.writeUTF(habilidades);
	    	                            canalSaida.writeUTF(interesses);
	    	                            canalSaida.writeUTF(cursos_realizados);
	    	                            canalSaida.writeUTF(tipo_GER_PROJ);
	    	                            canalSaida.writeUTF(email);
	    	                            canalSaida.writeUTF(tipo_ANA_SIS);
	    	                            canalSaida.writeUTF(tipo_DESG);
	    	                            canalSaida.writeUTF(tipo_PROG);
	    	                            canalSaida.writeUTF(tipo_TEST);
	    	                            
	    	                            
	    	                            
	    	            			 } catch(ClassNotFoundException e) {
	    	            	                System.out.println("excesso Classe no encontrada");
	    	            	                e.printStackTrace();
	    	            	            } catch(SQLException e) {
	    	            	                System.out.println("SQL Exception... Erro na consulta:");
	    	            	                e.printStackTrace();
	    	            	            } finally {
	    	            	                try {
	    	            	                    conn.close();
	    	            	                    System.out.println("\n\nFechamendo a conexo");
	    	            	                } catch(SQLException erro) {
	    	            	                    System.out.println("Erro no fechamento");
	    	            	                    erro.printStackTrace();
	    	            	                }
	    	            	            }
	    	            			 
	    	            			
	    	            			
	    	            			// fazer igual no cadastro (mesmas funes)
	    	            			
	    	            			
	    	            	            while(true){ // funes internas do atualiza
	    	            	            	int sub_opcao_2 = canalEntrada.readInt();
	    	            	            	
	    	            	            	if(sub_opcao_2 == 121){ // salvar e sair
	    	            	            	
	    	            	            		//l campos e armazena no DATABASE
	    	        	        				
	    	        	        				String Atualiza_Senha = canalEntrada.readUTF();
	    	        	        				
	    	        	        				
	    	        	        				Connection connb = null;
	    		    	            			String testeb = "SELECT  senha FROM dados WHERE login = '"+login_R+"';";
	    		    	            			
	    		    	            			
	    		    	            			 String senha = new String();
	    		    	            			try {
	    		    	                        	
	    		    	                            Class.forName("com.mysql.jdbc.Driver");
	    		    	                          
	    		    	                            connb = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	    		    	                            
	    		    	                            
	    		    	                             
	    		    	                            Statement stmk = connb.createStatement();  // para o banco dos users sockets
	    		    	                            ResultSet rsk = stmk.executeQuery(testeb); // banco users sockets
	    		    	                            
	    		    	                            
	    		    	                         
	    		    	                            while (rsk.next()) {
	    		    	                                
	    		    	                            	senha = rsk.getString("senha");
	    		    	                            	
	    		    	                            
	    		    	                            } // while
	    		    	            			
	    	        	        				
	    		    	            			} catch(ClassNotFoundException e) {
	    	    	            	                System.out.println("excesso Classe no encontrada");
	    	    	            	                e.printStackTrace();
	    	    	            	            } catch(SQLException e) {
	    	    	            	                System.out.println("SQL Exception... Erro na consulta:");
	    	    	            	                e.printStackTrace();
	    	    	            	            } finally {
	    	    	            	                try {
	    	    	            	                    conn.close();
	    	    	            	                    System.out.println("\n\nFechamendo a conexo");
	    	    	            	                } catch(SQLException erro) {
	    	    	            	                    System.out.println("Erro no fechamento");
	    	    	            	                    erro.printStackTrace();
	    	    	            	                }
	    	    	            	            }
	    	        	        				
	    	        	        				     				
	    	        	           				String Atualiza_Nome = canalEntrada.readUTF();
	    	        	        				String Atualiza_Formacao = canalEntrada.readUTF();
	    	        	        		     	String Atualiza_Email = canalEntrada.readUTF();
	    	        	        				String Tipo_GER_PROJ = canalEntrada.readUTF();
	    	        	        				String Tipo_ANA_SIS = canalEntrada.readUTF();
	    	        	        				String Tipo_DESG = canalEntrada.readUTF();
	    	        	        				String Tipo_PROG = canalEntrada.readUTF();
	    	        	        				String Tipo_TEST = canalEntrada.readUTF();
	    	        	        				String Atualiza_Habilidades = canalEntrada.readUTF();
	    	        	        				String Atualiza_Interesses = canalEntrada.readUTF();
	    	        	        				String Atualiza_Cursos_Realizados = canalEntrada.readUTF();
	    	        	        				 
	    	        	        				// Antes de ir armazenando tem que verificar quem est logado,
	    	        	        				
	    	        	        				      Class.forName("com.mysql.jdbc.Driver");
	    	        		       	                  // System.out.println("1 - OK");
	    	        		       	    	          Connection conn1 = null;
	    	        		       	                  conn1 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	    	        		       	                  Statement stm = conn1.createStatement();  // para o banco dos users sockets
	    	        	        				
	    	        	        				
	    	        	        				String teste1 = "UPDATE dados SET senha = '"+senha+"', nome = '"+Atualiza_Nome+"', formacao = '"+Atualiza_Formacao+"', habilidades = '"+Atualiza_Habilidades+"', interesses = '"+Atualiza_Interesses+"', cursos_realizados = '"+Atualiza_Cursos_Realizados+"', email = '"+Atualiza_Email+"', tipo_GER_PROJ = '"+Tipo_GER_PROJ+"', tipo_ANA = '"+Tipo_ANA_SIS+"'tipo_DESG = '"+Tipo_DESG+"', tipo_PROG = '"+Tipo_PROG+"', tipo_TEST = '"+Tipo_TEST+"' WHERE login = '"+login_R+"';";
	    	        	        				stm.executeUpdate(teste1);
	    	            	            		
	    	            	            		break;
	    	            	            	}
	    	            	            	
	    	            	            	if(sub_opcao_2 == 122){ // cancelar
	    	            	            		break;
	    	            	            	}
	    	            	            	
	    	            	            	
	    	            	            } // fim do while true
	    	            	            
	    	            			} // fim do else gerente	
	    	            			
	    	            		} // fim da sub_opcao = 12
	    	            		
	    	            		if(sub_opcao == 13){ // gerenciador de documentos
	    	            			System.out.println("ENTROU NO GERENCIADOR");
	    	            			
	    	            			int sub_opcao_2 = canalEntrada.readInt();
	    	            			
	    	            			if(sub_opcao_2 == 131){ // gravar o arquivo
	    	            			String nomedoc = canalEntrada.readUTF();
	    	            			String pathdoc = canalEntrada.readUTF();
	    	            			String datadoc = canalEntrada.readUTF();
	    	            			String horadoc = canalEntrada.readUTF();
	    	            			
	    	            			System.out.println("Nome: "+nomedoc+" Path: "+ pathdoc+" Data: "+datadoc+" Hora: "+horadoc);
	    	            			
	    	            			// converter data para date
	    	            			
	    	            			
	    	            			Class.forName("com.mysql.jdbc.Driver");
	    	            			Connection conn2 = null;
	    	            			conn2 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	    	            			
	    	            			
	    	            			 SimpleDateFormat df = new SimpleDateFormat("dd/MM/yyyy");  
	    	            			 java.util.Date dataUtil = df.parse(datadoc);  
	    	            			 java.sql.Date dataJDBC = new java.sql.Date(dataUtil.getTime()); 
	    	            			 
	    	            			 
	    	            			  String sql = "INSERT INTO ger_doc (nomedoc, pathdoc, data_doc, hora_doc, login) VALUES(?, ?, ?, ?, ?)";  
	    	            			  PreparedStatement prep = conn2.prepareStatement(sql);  
	    	            			            
	    	            			          try {  
	    	            			              // setar os campos (?) do SQL  
	    	            			              prep.setString(1, nomedoc);
	    	            			              prep.setString(2, pathdoc);
	    	            			              prep.setDate(3, dataJDBC);
	    	            			              prep.setString(4, horadoc);  
	    	            			              prep.setString(5, login_geral);  
	    	            			              // executar  
	    	            			              prep.executeUpdate();  
	    	            			          } finally {  
	    	            			              try {  
	    	            			                  prep.close();  
	    	            			              } catch (SQLException ex) {  
	    	            			                  ex.printStackTrace();  
	    	            			              }  
	    	            			          }  
	    	            			
	    	            				    	            			
	    	            			}
	    	            			
	    	            			
	    	            			
	    	            			if(sub_opcao_2 == 132){ // cancelar
	    	            				System.out.println("Entrou no cancelar gerdoc");	
	    	            			}
	    	            			
	    	            		}
	    	            		
	    	            		if(sub_opcao == 14){ // gerenciador de URL's
	    	            			//envia as urls do db
	    	            			Class.forName("com.mysql.jdbc.Driver");
	    	            			Connection conn2 = null;
	    	            			conn2 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	    	            			Statement stm2 = conn2.createStatement();  // para o banco dos users sockets
	    	            			String teste2 = "SELECT url FROM dados WHERE login = '"+login_geral+"';";
	    	            			ResultSet rs = stm2.executeQuery(teste2); // banco users sockets
	    	            			  
	    	            		  
	    	            			  String urls = new String();
	    	                          while (rs.next()){
	    	                              urls = rs.getString("url");
	    	                                 }
	    	       
	    	                          if(urls == null){
	    	                        	  urls = "#01";
	    	                          }
	    	            			// envia a url para o cliente
	    	            			canalSaida.writeUTF(urls);
	    	                          
	    	            			// receber dados de URL's, text no mysql??
	    	            			int sub_opcao_2 = canalEntrada.readInt();
	    	            			
	    	            			if(sub_opcao_2 == 141){ // salvar_e_sair
	    	            				String urls2 = canalEntrada.readUTF(); // recebe as urls
	    	            				System.out.println("URLS RECEBIDA: "+ urls2);
	    	            			  Class.forName("com.mysql.jdbc.Driver");
      		       	                  // System.out.println("1 - OK");
      		       	    	          Connection conn3 = null;
      		       	                  conn3 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
      		       	                  Statement stm3= conn3.createStatement();  // para o banco dos users sockets
      	        				
      	        				
      	        				String teste3 = "UPDATE dados SET url = '"+urls2+"' WHERE login = '"+login_geral+"';";
      	        				stm3.executeUpdate(teste3);
	    	            				System.out.println("EXECUTOU O SQL, login = "+login_geral);
	    	            			}
	    	            			
	    	            			if(sub_opcao_2 == 142){ // cancelar
	    	            				
	    	            				System.out.println("ENTROU NO CANCELAR REGURL");
	    	            				
	    	            			}
	    	            			
	    	            		}
	    	            		
	    	            		if(sub_opcao == 15){ // sair
	    	            			
	    	            			SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
	    	            	        System.out.println(sdf.format(new Date()));
	    	                        Data_Final = sdf.format(new Date()); // string pega
	    	                        

	    	                        SimpleDateFormat sdf_1 = new SimpleDateFormat("HH:mm:ss");
	    	            	        System.out.println(sdf_1.format(new Date()));
	    	                        Hora_Final = sdf_1.format(new Date()); // string pega
	    	            			
	    	                        // criar conexo com o mysql
	    	                        
	    	                        
	    	                        Class.forName("com.mysql.jdbc.Driver");
	    	            			Connection conn8 = null;
	    	            			conn8 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	    	            			Statement stm8 = conn8.createStatement();  // para o banco dos users sockets
	    	            			String teste8 = "INSERT INTO data_horario (Login, Data_Inicio,Data_Fim, Horario_Inicio, Horario_Fim) VALUES ('"+login_geral+"','"+Data_Inicial+"','"+Data_Final+"','"+Hora_Inicial+"','"+Hora_Final+"');";
	    	            			stm8.executeUpdate(teste8);
	    	                        
	    	            			
	    	            			break;
	    	            		}
	    	            		
	    	            		if(sub_opcao == 16){ // cadastrar usuario
	    	            			
	    	            			// entrou no Cadastrar Usurio
	    		        			
	    		        			
	    		        			while(true){
	    		        			
	    		        			int sub_opcao2 = canalEntrada.readInt();
	    		        			
	    		        			if(sub_opcao2 == 11){ // verificar login
	    		        				String Login_Recebido = canalEntrada.readUTF();
	    		        				int chave = 0;
	    		        				
	    		        				  Class.forName("com.mysql.jdbc.Driver");
	    		       	               // System.out.println("1 - OK");
	    		       	    	          Connection conn = null;
	    		       	                  conn = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	    		       	                  Statement stm = conn.createStatement();  // para o banco dos users sockets
	    		        				
	    		        				
	    		        				String teste_1 = "SELECT Login FROM dados;";
	    		        				ResultSet rs = stm.executeQuery(teste_1); // banco users sockets
	    		        				System.out.println("Entrouu no LOGIN");
	    		                        while (rs.next()) {
	    		                            String Login_1 = rs.getString("Login");
	    		                           if(Login_Recebido.equals(Login_1)){
	    		                             chave = 1; // login j existe
	    		                            }
	    		                        } // while
	    		        				
	    		        				// enviar anlise sobre o login
	    		                        if(chave == 1){
	    		                        	canalSaida.writeInt(chave);
		    		        				chave = 0;
		    		        				break;
   		                        	      }else{
	    		                        canalSaida.writeInt(chave);
	    		        				chave = 0;}
	    		        				
	    		        			}
	    		        			
	    		        			if(sub_opcao2 == 12){ // salvar_e_sair
	    		        				//l campos e armazena no DATABASE
	    		        				String Cadastro_Login = canalEntrada.readUTF();
	    		        				//String Cadastro_Senha = PasswordGenerator.make(); // gera a senha
	    		        				//Mailer sm = new Mailer();
	    		        				String Cadastro_Nome = canalEntrada.readUTF();
	    		        				String Cadastro_Formacao = canalEntrada.readUTF();
	    		        				String Cadastro_Habilidades = canalEntrada.readUTF();
	    		        				String Cadastro_Interesses = canalEntrada.readUTF();
	    		        				String Cadastro_Cursos_Realizados = canalEntrada.readUTF();
	    		        				
	    		        				//******receber o tipo do usuario**********************
	    		        				
	    		        				String Cadastro_Tipo_GER_PROJ = canalEntrada.readUTF();
	    		        				String Cadastro_Tipo_ANA_SIS = canalEntrada.readUTF();
	    		        				String Cadastro_Tipo_DESG = canalEntrada.readUTF();
	    		        				String Cadastro_Tipo_PROG = canalEntrada.readUTF();
	    		        				String Cadastro_Tipo_TEST = canalEntrada.readUTF();
	    		        				
	    		        				
	    		        				String Cadastro_Email = canalEntrada.readUTF();
	    		        				String Cadastro_Senha = "lala"; // senha qualquer, pois vai gerar uma para o usurio
	    		        				
	    		        				
	    		        				Class.forName("com.mysql.jdbc.Driver");
  			       	                  // System.out.println("1 - OK");
  			       	    	          Connection conn1 = null;
  			       	                  conn1 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
  			       	                  Statement stm1 = conn1.createStatement();  // para o banco dos users sockets
  		        				
  		        				//System.out.println("CAD_SENHA = "+Cadastro_Senha);
  		        				String teste = "INSERT INTO dados (login, senha, nome, formacao, habilidades, interesses, cursos_realizados, tipo_GER_PROJ, email, tipo_ANA, tipo_DESG, tipo_PROG, tipo_TEST) VALUES ('"+Cadastro_Login+"','"+Cadastro_Senha+"','"+Cadastro_Nome+"','"+Cadastro_Formacao+"','"+Cadastro_Habilidades+"','"+Cadastro_Interesses+"','"+Cadastro_Cursos_Realizados+"','"+Cadastro_Tipo_GER_PROJ+"','"+Cadastro_Email+"','"+Cadastro_Tipo_ANA_SIS+"','"+Cadastro_Tipo_DESG+"','"+Cadastro_Tipo_PROG+"','"+Cadastro_Tipo_TEST+"');";
  		        				stm1.executeUpdate(teste);
	    		        				
	    		        				
	    		        				 SensorBaseClient.registerUser("http://localhost:9876/sensorbase/", Cadastro_Login);
	    		        				 	    		        				 
	    		        				      
	    		        				break;
	    		        			}
	    		        			
	    		        			if(sub_opcao2 == 13){ // sair
	    		        				break;
	    		        			}
	    		        		
	    		        		} // fim do while true - cadastrar usuario
	    	            			
	    	            			
	    	            		}
	    	            		
	    	            		
	    	            		if(sub_opcao == 17){ // informaes sobre usurios
	    	            		  //enviar o nmero de usurios existentes
	    	            			
	    	            			Connection connx = null;
	    	            			String teste6 = "SELECT COUNT(*) FROM dados;";
	    	            			
	    	            			System.out.println("COUNTTT ");
	    	            			try{
	    	            			Class.forName("com.mysql.jdbc.Driver");
	    	                          
    	                            connx = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
    	                            
    	                            
    	                             
    	                            Statement stm = connx.createStatement();  // para o banco dos users sockets
    	                            int  cont_aux = 0;
    	                               
    	                            ResultSet rs = stm.executeQuery(teste6);  
    	                            if (!rs.next())  
    	                            throw new SQLException("erro ao ler o tipo do curso: ");  
    	                            
    	                            System.out.println(rs.getInt("count(*)"));  
    	                            int qtde_nomes = rs.getInt("count(*)");
    	                            canalSaida.writeInt(qtde_nomes); 
    	                            
    	                           String teste7 = "SELECT login from dados;";
    	                            Statement stm1 = connx.createStatement();
    	                            ResultSet rs1 = stm.executeQuery(teste7);  
    	                            String nomes = new String();
    	                            while(rs1.next()){
    	                            	canalSaida.writeUTF(rs1.getString("login"));
    	                            	
    	                            	cont_aux++;
    	                            }
    	                            System.out.println("Cont_Aux = "+cont_aux);
    	                            
	    	            			} catch(ClassNotFoundException e) {
    	            	                System.out.println("excesso Classe no encontrada");
    	            	                e.printStackTrace();
    	            	            } catch(SQLException e) {
    	            	                System.out.println("SQL Exception... Erro na consulta:");
    	            	                e.printStackTrace();
    	            	            } finally {
    	            	                try {
    	            	                    connx.close();
    	            	                    System.out.println("\n\nFechamendo a conexo");
    	            	                } catch(SQLException erro) {
    	            	                    System.out.println("Erro no fechamento");
    	            	                    erro.printStackTrace();
    	            	                }
    	            	            }
	    	            		int sub_op = canalEntrada.readInt();
	    	            		
	    	            		 if(sub_op == 171){ // ficha usurio
	    	            			String S = canalEntrada.readUTF(); // recebe login
		    	            			
		    	            			Connection conn = null;
		    	            			String teste = "SELECT  senha, nome, formacao, habilidades, interesses, cursos_realizados, tipo_GER_PROJ, email, tipo_ANA, tipo_DESG, tipo_PROG, tipo_TEST FROM dados WHERE login = '"+S+"';";
		    	            			
		    	            			
		    	            			
		    	            			try {
		    	                        	
		    	                            Class.forName("com.mysql.jdbc.Driver");
		    	                          
		    	                            conn = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
		    	                            
		    	                            
		    	                             
		    	                            Statement stm = conn.createStatement();  // para o banco dos users sockets
		    	                            ResultSet rs = stm.executeQuery(teste); // banco users sockets
		    	                            
		    	                            
		    	                            String senha = new String();
		    	                            String nome = new String();
		    	                            String formacao = new String();
		    	                            String habilidades = new String();
		    	                            String interesses = new String();
		    	                            String cursos_realizados = new String();
		    	                            String tipo_GER_PROJ = new String();
		    	                            String email = new String();
		    	                            String tipo_ANA_SIS = new String();
		    	                            String tipo_DESG = new String();
		    	                            String tipo_PROG = new String();
		    	                            String tipo_TEST = new String();
		    	                            
		    	                            
		    	                            
		    	                            
		    	                            while (rs.next()) {
		    	                                
		    	                            	senha = rs.getString("senha");
		    	                            	nome = rs.getString("nome");
		    	                            	formacao = rs.getString("formacao");
		    	                                habilidades = rs.getString("habilidades");
		    	                            	interesses = rs.getString("interesses");
		    	                            	cursos_realizados = rs.getString("cursos_realizados");
		    	                            	tipo_GER_PROJ = rs.getString("tipo_GER_PROJ");
		    	                            	email = rs.getString("email");
		    	                            	tipo_ANA_SIS = rs.getString("tipo_ANA");
		    	                             	tipo_DESG = rs.getString("tipo_DESG");
		    	                            	tipo_PROG = rs.getString("tipo_PROG");
		    	                            	tipo_TEST = rs.getString("tipo_TEST");
		    	                            } // while
		    	            			
		    	                            System.out.println("HABILIDADES: "+habilidades);
		    	                            System.out.println("INTERESSES: "+interesses);
		    	                            System.out.println("CURSOSREALIZADOSS: "+cursos_realizados);
		    	                            
		    	                            
		    	                            
		    	                            // envia para o atualiza cadastro os dados
		    	                           
		    	                            canalSaida.writeUTF(nome);
		    	                            canalSaida.writeUTF(formacao);
		    	                            canalSaida.writeUTF(habilidades);
		    	                            canalSaida.writeUTF(interesses);
		    	                            canalSaida.writeUTF(cursos_realizados);
		    	                            canalSaida.writeUTF(tipo_GER_PROJ);
		    	                            canalSaida.writeUTF(email);
		    	                            canalSaida.writeUTF(tipo_ANA_SIS);
		    	                            canalSaida.writeUTF(tipo_DESG);
		    	                            canalSaida.writeUTF(tipo_PROG);
		    	                            canalSaida.writeUTF(tipo_TEST);
		    	                            
		    	                            
		    	            			 } catch(ClassNotFoundException e) {
		    	            	                System.out.println("excesso Classe no encontrada");
		    	            	                e.printStackTrace();
		    	            	            } catch(SQLException e) {
		    	            	                System.out.println("SQL Exception... Erro na consulta:");
		    	            	                e.printStackTrace();
		    	            	            } finally {
		    	            	                try {
		    	            	                    conn.close();
		    	            	                    System.out.println("\n\nFechamendo a conexo");
		    	            	                } catch(SQLException erro) {
		    	            	                    System.out.println("Erro no fechamento");
		    	            	                    erro.printStackTrace();
		    	            	                }
		    	            	            }
		    	            			
	    	            			 
	    	            			 
	    	            			 
	    	            			 
	    	            			 
	    	            		 }
	    	            		 if(sub_op == 172){
	    	            			//cancelar
	    	            		 }
	    	            		
	    	            		}
	    	            		
	    	            		if(sub_opcao == 18){ // informaes sobre doc/user
	    	            			
	    	            			Connection connx = null;
	    	            			String teste6 = "SELECT COUNT(*) FROM dados;";
	    	            			
	    	            			System.out.println("COUNTTT ");
	    	            			try{
	    	            			Class.forName("com.mysql.jdbc.Driver");
	    	                          
    	                            connx = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
    	                            
    	                            
    	                             
    	                            Statement stm = connx.createStatement();  // para o banco dos users sockets
    	                            int  cont_aux = 0;
    	                               
    	                            ResultSet rs = stm.executeQuery(teste6);  
    	                            if (!rs.next())  
    	                            throw new SQLException("erro ao ler o tipo do curso: ");  
    	                            
    	                            System.out.println(rs.getInt("count(*)"));  
    	                            int qtde_nomes = rs.getInt("count(*)");
    	                            canalSaida.writeInt(qtde_nomes); 
    	                            
    	                           String teste7 = "SELECT login from dados;";
    	                            Statement stm1 = connx.createStatement();
    	                            ResultSet rs1 = stm.executeQuery(teste7);  
    	                            String nomes = new String();
    	                            while(rs1.next()){
    	                            	canalSaida.writeUTF(rs1.getString("login"));
    	                            	
    	                            	cont_aux++;
    	                            }
    	                            System.out.println("Cont_Aux = "+cont_aux);
    	                            
	    	            			} catch(ClassNotFoundException e) {
    	            	                System.out.println("excesso Classe no encontrada");
    	            	                e.printStackTrace();
    	            	            } catch(SQLException e) {
    	            	                System.out.println("SQL Exception... Erro na consulta:");
    	            	                e.printStackTrace();
    	            	            } finally {
    	            	                try {
    	            	                    connx.close();
    	            	                    System.out.println("\n\nFechamendo a conexo");
    	            	                } catch(SQLException erro) {
    	            	                    System.out.println("Erro no fechamento");
    	            	                    erro.printStackTrace();
    	            	                }
    	            	            }
	    	            			
    	            	            int sub_op = canalEntrada.readInt();
    	    	            		
   	    	            		 if(sub_op == 181){ // ficha documento/usurio
   	    	            			String S = canalEntrada.readUTF(); // recebe login
   	    	            			String Data_I = canalEntrada.readUTF();
   	    	            			String Data_F = canalEntrada.readUTF();
   		    	            			
   	    	            			
   	    	            			System.out.println("Data_Inicial Passada: "+ Data_I);
   	    	            			System.out.println("Data_Inicial Passada: "+ Data_F);
   	    	            			System.out.println("Login: "+ S);
   		    	            			Connection con18 = null;
   		    	            			Connection con20 = null;
   		    	            			
   		    	            			// converter as datas para tipo date e deposi desconverter antes de enviar para o usurio
   		    	            			
   		    	            			
   		    	            		 SimpleDateFormat df = new SimpleDateFormat("dd/MM/yyyy");  
	    	            			 java.util.Date dataUtil = df.parse(Data_I);  
	    	            			 java.sql.Date datai = new java.sql.Date(dataUtil.getTime()); 
	    	            			 
	    	            			 SimpleDateFormat df2 = new SimpleDateFormat("dd/MM/yyyy");  
	    	            			 java.util.Date dataUtil2 = df2.parse(Data_F);  
	    	            			 java.sql.Date dataf = new java.sql.Date(dataUtil2.getTime());
	    	            			
	    	            			 
   		    	            			
   		    	            			
   		    	            			String cons = "SELECT nomedoc, pathdoc, data_doc, hora_doc from ger_doc where data_doc >= '"+datai+"' and data_doc <= '"+dataf+"' and login = '"+S+"';";
   		    	            			String nome_doc = new String();
		    	                        String path_doc = new String();
		    	                        java.sql.Date data_doc;
		    	                        String hora_doc = new String();
   		    	            			
   		    	            			try {
   		    	                        	
   		    	                            Class.forName("com.mysql.jdbc.Driver");
   		    	                          
   		    	                            con18 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
   		    	                            
   		    	                            
   		    	                             
   		    	                            Statement stm = con18.createStatement();  // para o banco dos users sockets
   		    	                            ResultSet rsc = stm.executeQuery(cons); // banco users sockets
   		    	                            
   		    	                            
   		    	                            
   		    	                            
   		    	                            int cont_aux = 0;
   		    	                            while (rsc.next()) {
   		    	                                
   		    	                            	nome_doc = rsc.getString("nomedoc");
   		    	                            	path_doc = rsc.getString("pathdoc");
   		    	                            	data_doc = rsc.getDate("data_doc");
   		    	                            	hora_doc = rsc.getString("hora_doc");
   		    	                                cont_aux++;
   		    	                                System.out.println("CONTX");
   		    	                            } // while
   		    	                            System.out.println("CONTX = " + cont_aux);
   		    	                            canalSaida.writeInt(cont_aux);
   		    	                            System.out.println("CONTX = " + cont_aux);
   		    	                            
   		    	                            
   		    	            			 } catch(ClassNotFoundException e) {
   		    	            	                System.out.println("excesso Classe no encontrada");
   		    	            	                e.printStackTrace();
   		    	            	            } catch(SQLException e) {
   		    	            	                System.out.println("SQL Exception... Erro na consulta:");
   		    	            	                e.printStackTrace();
   		    	            	            } finally {
   		    	            	                try {
   		    	            	                    con18.close();
   		    	            	                    System.out.println("\n\nFechamendo a conexo");
   		    	            	                } catch(SQLException erro) {
   		    	            	                    System.out.println("Erro no fechamento");
   		    	            	                    erro.printStackTrace();
   		    	            	                }
   		    	            	            }
   		    	            			
   		    	            	         try {
    		    	                        	
    		    	                            Class.forName("com.mysql.jdbc.Driver");
   	    	            			 
   		    	            	            con20 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
		    	                            
		    	                            
	    	                             
		    	                            Statement stm20 = con20.createStatement();  // para o banco dos users sockets
		    	                            ResultSet rsd = stm20.executeQuery(cons); // banco users sockets
		    	                            
		    	                            
		    	                         
		    	                            
		    	                      while (rsd.next()) {
		    	                                
		    	                            	nome_doc = rsd.getString("nomedoc");
		    	                            	canalSaida.writeUTF(nome_doc);
		    	                            	path_doc = rsd.getString("pathdoc");
		    	                            	canalSaida.writeUTF(path_doc);
		    	                            	data_doc = rsd.getDate("data_doc");
		    	                            	SimpleDateFormat iso = new SimpleDateFormat("dd/MM/yyyy");  
		    	                            	String dataISO = iso.format(data_doc); 
		    	                            	
		    	                            	canalSaida.writeUTF(dataISO);
		    	                            	hora_doc = rsd.getString("hora_doc");
		    	                            	canalSaida.writeUTF(hora_doc);
		    	                               
		    	                            } // while   
		    	                         
   		    	            	      } catch(ClassNotFoundException e) {
		    	            	                System.out.println("excesso Classe no encontrada");
		    	            	                e.printStackTrace();
		    	            	            } catch(SQLException e) {
		    	            	                System.out.println("SQL Exception... Erro na consulta:");
		    	            	                e.printStackTrace();
		    	            	            } finally {
		    	            	                try {
		    	            	                    con20.close();
		    	            	                    System.out.println("\n\nFechamendo a conexo");
		    	            	                } catch(SQLException erro) {
		    	            	                    System.out.println("Erro no fechamento");
		    	            	                    erro.printStackTrace();
		    	            	                }
		    	            	            }
   	    	            			 
   	    	            			 
   	    	            			 
   	    	            		 }
   	    	            		 if(sub_op == 182){
   	    	            			//cancelar
   	    	            		 }

	            	            
	    	            			
	    	            		}
	    	            		
	    	            		
	    	            		if(sub_opcao == 19){ // remover usurio
	    	            			
	    	            				    	            			
                                       //enviar o nmero de usurios existentes
 	    	            			
	    	            			Connection connx = null;
	    	            			String teste6 = "SELECT COUNT(*) FROM dados;";
	    	            			
	    	            			System.out.println("COUNTTT ");
	    	            			try{
	    	            			Class.forName("com.mysql.jdbc.Driver");
	    	                          
    	                            connx = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
    	                            
    	                            
    	                             
    	                            Statement stm = connx.createStatement();  // para o banco dos users sockets
    	                            int  cont_aux = 0;
    	                               
    	                            ResultSet rs = stm.executeQuery(teste6);  
    	                            if (!rs.next())  
    	                            throw new SQLException("erro ao ler o tipo do curso: ");  
    	                            
    	                            System.out.println(rs.getInt("count(*)"));  
    	                            int qtde_nomes = rs.getInt("count(*)");
    	                            canalSaida.writeInt(qtde_nomes); 
    	                            
    	                           String teste7 = "SELECT login from dados;";
    	                            Statement stm1 = connx.createStatement();
    	                            ResultSet rs1 = stm.executeQuery(teste7);  
    	                            String nomes = new String();
    	                            while(rs1.next()){
    	                            	canalSaida.writeUTF(rs1.getString("login"));
    	                            	
    	                            	cont_aux++;
    	                            }
    	                            System.out.println("Cont_Aux = "+cont_aux);
    	                            
	    	            			} catch(ClassNotFoundException e) {
    	            	                System.out.println("excesso Classe no encontrada");
    	            	                e.printStackTrace();
    	            	            } catch(SQLException e) {
    	            	                System.out.println("SQL Exception... Erro na consulta:");
    	            	                e.printStackTrace();
    	            	            } finally {
    	            	                try {
    	            	                    connx.close();
    	            	                    System.out.println("\n\nFechamendo a conexo");
    	            	                } catch(SQLException erro) {
    	            	                    System.out.println("Erro no fechamento");
    	            	                    erro.printStackTrace();
    	            	                }
    	            	            }
	    	            			
    	            	            int sub_op = canalEntrada.readInt();
    	            	            
    	            	            if(sub_op == 191){// ok
    	            	            	String S = canalEntrada.readUTF(); // recebe login
    	            	            	
    	            	            	// criar conexo com o mysql
    	    	                        
    	    	                        
    	    	                        Class.forName("com.mysql.jdbc.Driver");
    	    	            			Connection conn12 = null;
    	    	            			conn12 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
    	    	            			Statement stm12 = conn12.createStatement();  // para o banco dos users sockets
    	    	            			String teste12 = "DELETE FROM dados WHERE login = '"+S+"';";
    	    	            			stm12.executeUpdate(teste12);
    	            	            	
    	            	            	
    	            	            }
	    	            			
    	            	            if(sub_op == 192){
    	    	            			//cancelar
    	    	            		 }
	    	            			
	    	            		} // fim sub_opo 19
	    	            		
	    	            		
	    	            		
	    	            		
	    	            		if(sub_opcao == 20){ // menu projeto
	    	            			
	    	            			
	    	            			while(true){ // entrou automaticamente no opes do Projeto
	    	    	            		
	    	    	            		int sub_op = canalEntrada.readInt();
	    	            			
	    	    	            		if(sub_op == 21){ // Cadastrar Projeto
	    	    	            			
	    	    	            			while(true){
	    	    	            			
	    	    	            			int sub_op1 = canalEntrada.readInt();
	    	    	            			
	    	    	            			if(sub_op1 == 211){ // verificar nome do projeto
	    	    	            				
	    	    	            				String Login_Recebido = canalEntrada.readUTF();
	    	    		        				int chave = 0;
	    	    		        				
	    	    		        				  Class.forName("com.mysql.jdbc.Driver");
	    	    		       	               // System.out.println("1 - OK");
	    	    		       	    	          Connection conn = null;
	    	    		       	                  conn = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	    	    		       	                  Statement stm = conn.createStatement();  // para o banco dos users sockets
	    	    		        				
	    	    		        				
	    	    		        				String teste_1 = "SELECT Nome FROM proj_info;";
	    	    		        				ResultSet rs = stm.executeQuery(teste_1); // banco users sockets
	    	    		        				//System.out.println("Entrouu no LOGIN");
	    	    		                        while (rs.next()) {
	    	    		                            String Login_1 = rs.getString("Nome");
	    	    		                           if(Login_Recebido.equals(Login_1)){
	    	    		                             chave = 1; // login j existe
	    	    		                            }
	    	    		                        } // while
	    	    		        				
	    	    		        				// enviar anlise sobre o login
	    	    		                        
	    	    		                        canalSaida.writeInt(chave);
	    	    		        				chave = 0;
	    	    	            				
	    	    	            				
	    	    	            			  }
	    	    	            			
	    	    	            			if(sub_op1 == 212){ // cadastrar
	    	    	            				
	    	    	            				//l campos e armazena no DATABASE
	    	    		        				String Cadastro_Nome = canalEntrada.readUTF();
	    	    		        				String Cadastro_Orcam = canalEntrada.readUTF();
	    	    		           				String Cadastro_DAI = canalEntrada.readUTF();
	    	    		        				String Cadastro_DAF = canalEntrada.readUTF();
	    	    		        				
	    	    		        				
	    	    		        				
	    	    		        				      Class.forName("com.mysql.jdbc.Driver");
	    	    			       	                  // System.out.println("1 - OK");
	    	    			       	    	          Connection connx4 = null;
	    	    			       	                  connx4 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	    	    			       	                  Statement stmx4 = connx4.createStatement();  // para o banco dos users sockets
	    	    		        				
	    	    		        				
	    	    		        				String testex4 = "INSERT INTO proj_info (Nome, Orcamento, DataInicial, DataFinal) VALUES ('"+Cadastro_Nome+"','"+Cadastro_Orcam+"','"+Cadastro_DAI+"','"+Cadastro_DAF+"');";
	    	    		        				stmx4.executeUpdate(testex4);
	    	    		        				break;
	    	    		        			}
	    	    	            				
	    	    	            				
	    	    	            				
	    	    	            			
	    	    	            			
	    	    	            			if(sub_op1 == 213){ // cancelar
	    	    	            				break;
	    	    	            				
	    	    	            			  }
	    	    	            			
	    	    	            			} // fim do while true
	    	    	            	
	    	    	            		} // fim do cadastrar
	    	    	            		
	    	    	            		if(sub_op == 22){ // visualizar
	    	    	            		
	    	    	            			
	    	    	            			
	    	    	            			//enviar o nmero de usurios existentes
	     	    	            			
	    	    	            			Connection connx = null;
	    	    	            			String teste6 = "SELECT COUNT(*) FROM proj_info;";
	    	    	            			
	    	    	            			System.out.println("COUNTTT ");
	    	    	            			try{
	    	    	            			Class.forName("com.mysql.jdbc.Driver");
	    	    	                          
	        	                            connx = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	        	                            
	        	                            
	        	                             
	        	                            Statement stm = connx.createStatement();  // para o banco dos users sockets
	        	                            int  cont_aux = 0;
	        	                               
	        	                            ResultSet rs = stm.executeQuery(teste6);  
	        	                            if (!rs.next())  
	        	                            throw new SQLException("erro ao ler o tipo do curso: ");  
	        	                            
	        	                            System.out.println(rs.getInt("count(*)"));  
	        	                            int qtde_nomes = rs.getInt("count(*)");
	        	                            canalSaida.writeInt(qtde_nomes); 
	        	                            
	        	                           String teste7 = "SELECT Nome from proj_info;";
	        	                            Statement stm1 = connx.createStatement();
	        	                            ResultSet rs1 = stm.executeQuery(teste7);  
	        	                            String nomes = new String();
	        	                            while(rs1.next()){
	        	                            	canalSaida.writeUTF(rs1.getString("Nome"));
	        	                            	
	        	                            	cont_aux++;
	        	                            }
	        	                            System.out.println("Cont_Aux = "+cont_aux);
	        	                            
	    	    	            			} catch(ClassNotFoundException e) {
	        	            	                System.out.println("excesso Classe no encontrada");
	        	            	                e.printStackTrace();
	        	            	            } catch(SQLException e) {
	        	            	                System.out.println("SQL Exception... Erro na consulta:");
	        	            	                e.printStackTrace();
	        	            	            } finally {
	        	            	                try {
	        	            	                    connx.close();
	        	            	                    System.out.println("\n\nFechamendo a conexo");
	        	            	                } catch(SQLException erro) {
	        	            	                    System.out.println("Erro no fechamento");
	        	            	                    erro.printStackTrace();
	        	            	                }
	        	            	            }
	    	    	            			
	        	            	            int sub_op2 = canalEntrada.readInt();
	        	            	            
	        	            	            if(sub_op2 == 221){// ok
	        	            	            	
	        	            	            	String S = canalEntrada.readUTF(); // recebe nome proj
	           	    	            			
	           		    	            			
	           	    	            			
	           		    	            			Connection con18 = null;
	           		    	            			Connection con20 = null;
	           		    	            			
	           		    	            			
	           		    	            			String cons = "SELECT Orcamento, DataInicial, DataFinal from proj_info where nome = '"+S+"';";
	           		    	            		    String Orcamento = new String();
	        		    	                        String DataInicial = new String();
	        		    	                        String DataFinal = new String();
	           		    	            			
	           		    	            			try {
	           		    	                        	
	           		    	                            Class.forName("com.mysql.jdbc.Driver");
	           		    	                          
	           		    	                            con18 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	           		    	                            
	           		    	                            
	           		    	                             
	           		    	                            Statement stm = con18.createStatement();  // para o banco dos users sockets
	           		    	                            ResultSet rsc = stm.executeQuery(cons); // banco users sockets
	           		    	                            
	           		    	                            
	           		    	                            
	           		    	                            
	           		    	                            int cont_aux = 0;
	           		    	                            while (rsc.next()) {
	           		    	                                
	           		    	                            	
	           		    	                            	Orcamento = rsc.getString("Orcamento");
	           		    	                            	DataInicial = rsc.getString("DataInicial");
	           		    	                            	DataFinal = rsc.getString("DataFinal");
	           		    	                                cont_aux++;
	           		    	                            } // while
	           		    	            			
	           		    	                            canalSaida.writeInt(cont_aux);
	           		    	                            
	           		    	                            
	           		    	                            
	           		    	            			 } catch(ClassNotFoundException e) {
	           		    	            	                System.out.println("excesso Classe no encontrada");
	           		    	            	                e.printStackTrace();
	           		    	            	            } catch(SQLException e) {
	           		    	            	                System.out.println("SQL Exception... Erro na consulta:");
	           		    	            	                e.printStackTrace();
	           		    	            	            } finally {
	           		    	            	                try {
	           		    	            	                    con18.close();
	           		    	            	                    System.out.println("\n\nFechamendo a conexo");
	           		    	            	                } catch(SQLException erro) {
	           		    	            	                    System.out.println("Erro no fechamento");
	           		    	            	                    erro.printStackTrace();
	           		    	            	                }
	           		    	            	            }
	           		    	            			
	           		    	            	         try {
	            		    	                        	
	            		    	                            Class.forName("com.mysql.jdbc.Driver");
	           	    	            			 
	           		    	            	            con20 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	        		    	                            
	        		    	                            
	        	    	                             
	        		    	                            Statement stm20 = con20.createStatement();  // para o banco dos users sockets
	        		    	                            ResultSet rsd = stm20.executeQuery(cons); // banco users sockets
	        		    	                            
	        		    	                            
	        		    	                         
	        		    	                            
	        		    	                      while (rsd.next()) {
	        		    	                                
	        		    	                            	Orcamento = rsd.getString("Orcamento");
	        		    	                            	canalSaida.writeUTF(Orcamento);
	        		    	                            	DataInicial = rsd.getString("DataInicial");
	        		    	                            	canalSaida.writeUTF(DataInicial);
	        		    	                            	DataFinal = rsd.getString("DataFinal");
	        		    	                            	canalSaida.writeUTF(DataFinal);
	        		    	                               
	        		    	                            } // while   
	        		    	                         
	           		    	            	      } catch(ClassNotFoundException e) {
	        		    	            	                System.out.println("excesso Classe no encontrada");
	        		    	            	                e.printStackTrace();
	        		    	            	            } catch(SQLException e) {
	        		    	            	                System.out.println("SQL Exception... Erro na consulta:");
	        		    	            	                e.printStackTrace();
	        		    	            	            } finally {
	        		    	            	                try {
	        		    	            	                    con20.close();
	        		    	            	                    System.out.println("\n\nFechamendo a conexo");
	        		    	            	                } catch(SQLException erro) {
	        		    	            	                    System.out.println("Erro no fechamento");
	        		    	            	                    erro.printStackTrace();
	        		    	            	                }
	        		    	            	            }
	           	    	            			
	        	            	            }
	    	    	            			
	        	            	            if(sub_op == 222){
	        	    	            			//cancelar
	        	    	            		 }
	    	    	            			
	    	    	            	} // fim do 22
	    	    	            		
	    	    	            		if(sub_op == 23){ // sair
	    	    	            			
	    	    	            			break;
	    	    	            			
	    	    	            		}
	    	    	            		
	    	            			}// fim do whiletrue
	    	            			
	    	            		} // fim da sub_opcao 20
	    	            		
	    	            		if(sub_opcao == 300){
	    	            			
	    	            			
	    	            			//envia as urls do db
	    	            			Class.forName("com.mysql.jdbc.Driver");
	    	            			Connection conn2 = null;
	    	            			conn2 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	    	            			Statement stm2 = conn2.createStatement();  // para o banco dos users sockets
	    	            			String teste2 = "SELECT Lista FROM lista_req WHERE num_seq = "+1+";";
	    	            			ResultSet rs = stm2.executeQuery(teste2); // banco users sockets
	    	            			  
	    	            		  
	    	            			  String lista = new String();
	    	                          while (rs.next()){
	    	                              lista = rs.getString("Lista");
	    	                                 }
	    	       
	    	                          if(lista == null){
	    	                        	  lista = "#01";
	    	                          }
	    	            			// envia a url para o cliente
	    	            			canalSaida.writeUTF(lista);
	    	                          
	    	            			// receber dados de URL's, text no mysql??
	    	            			int sub_opcao_2 = canalEntrada.readInt();
	    	            			
	    	            			if(sub_opcao_2 == 301){ // salvar_e_sair
	    	            				String lista2 = canalEntrada.readUTF(); // recebe a lista
	    	            				System.out.println("URLS RECEBIDA: "+ lista2);
	    	            			  Class.forName("com.mysql.jdbc.Driver");
      		       	                  // System.out.println("1 - OK");
      		       	    	          Connection conn3 = null;
      		       	                  conn3 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
      		       	                  Statement stm3= conn3.createStatement();  // para o banco dos users sockets
      	        				
      	        				
      	        				String teste3 = "UPDATE lista_req SET Lista = '"+lista2+"' WHERE num_seq = "+1+";";
      	        				stm3.executeUpdate(teste3);
	    	            				System.out.println("EXECUTOU O SQL, login = "+login_geral);
	    	            			}
	    	            			
	    	            			if(sub_opcao_2 == 302){ // cancelar
	    	            				
	    	            				System.out.println("ENTROU NO CANCELAR REGURL");
	    	            				
	    	            			}
	    	            			
	    	            		} // fim da sub_opcao 300
	    	            		
	    	            		
	    	            		
	    	            		if(sub_opcao == 400){
	    	            			
	    	            			
	    	            			//envia as urls do db
	    	            			Class.forName("com.mysql.jdbc.Driver");
	    	            			Connection conn2 = null;
	    	            			conn2 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
	    	            			Statement stm2 = conn2.createStatement();  // para o banco dos users sockets
	    	            			String teste2 = "SELECT lista FROM test_res WHERE num_seq = "+1+";";
	    	            			ResultSet rs = stm2.executeQuery(teste2); // banco users sockets
	    	            			  
	    	            		  
	    	            			  String lista = new String();
	    	                          while (rs.next()){
	    	                              lista = rs.getString("lista");
	    	                                 }
	    	       
	    	                          if(lista == null){
	    	                        	  lista = "#01";
	    	                          }
	    	            			// envia a url para o cliente
	    	            			canalSaida.writeUTF(lista);
	    	                          
	    	            			// receber dados de URL's, text no mysql??
	    	            			int sub_opcao_2 = canalEntrada.readInt();
	    	            			
	    	            			if(sub_opcao_2 == 401){ // salvar_e_sair
	    	            				String lista2 = canalEntrada.readUTF(); // recebe a lista
	    	            				System.out.println("URLS RECEBIDA: "+ lista2);
	    	            			  Class.forName("com.mysql.jdbc.Driver");
      		       	                  // System.out.println("1 - OK");
      		       	    	          Connection conn3 = null;
      		       	                  conn3 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
      		       	                  Statement stm3= conn3.createStatement();  // para o banco dos users sockets
      	        				
      	        				
      	        				String teste3 = "UPDATE test_res SET lista = '"+lista2+"' WHERE num_seq = "+1+";";
      	        				stm3.executeUpdate(teste3);
	    	            				System.out.println("EXECUTOU O SQL, login = "+login_geral);
	    	            			}
	    	            			
	    	            			if(sub_opcao_2 == 402){ // cancelar
	    	            				
	    	            				System.out.println("ENTROU NO CANCELAR REGURL");
	    	            				
	    	            			}
	    	            			
	    	            			
	    	            		} // fim da sub_opcao 400
	    	            		
	    	            		
	    	            		if(sub_opcao == 500){ // SENSOR_INFO
	    	            			
	    	            			Connection connx = null;
	    	            			String teste6 = "SELECT COUNT(*) FROM dados;";
	    	            			
	    	            			System.out.println("COUNTTT ");
	    	            			try{
	    	            			Class.forName("com.mysql.jdbc.Driver");
	    	                          
    	                            connx = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
    	                            
    	                            
    	                             
    	                            Statement stm = connx.createStatement();  // para o banco dos users sockets
    	                            int  cont_aux = 0;
    	                               
    	                            ResultSet rs = stm.executeQuery(teste6);  
    	                            if (!rs.next())  
    	                            throw new SQLException("erro ao ler o tipo do curso: ");  
    	                            
    	                            System.out.println(rs.getInt("count(*)"));  
    	                            int qtde_nomes = rs.getInt("count(*)");
    	                            canalSaida.writeInt(qtde_nomes); 
    	                            
    	                           String teste7 = "SELECT login from dados;";
    	                            Statement stm1 = connx.createStatement();
    	                            ResultSet rs1 = stm.executeQuery(teste7);  
    	                            String nomes = new String();
    	                            while(rs1.next()){
    	                            	canalSaida.writeUTF(rs1.getString("login"));
    	                            	
    	                            	cont_aux++;
    	                            }
    	                            System.out.println("Cont_Aux = "+cont_aux);
    	                            
	    	            			} catch(ClassNotFoundException e) {
    	            	                System.out.println("excesso Classe no encontrada");
    	            	                e.printStackTrace();
    	            	            } catch(SQLException e) {
    	            	                System.out.println("SQL Exception... Erro na consulta:");
    	            	                e.printStackTrace();
    	            	            } finally {
    	            	                try {
    	            	                    connx.close();
    	            	                    System.out.println("\n\nFechamendo a conexo");
    	            	                } catch(SQLException erro) {
    	            	                    System.out.println("Erro no fechamento");
    	            	                    erro.printStackTrace();
    	            	                }
    	            	            }
	    	            			
    	            	            int sub_op = canalEntrada.readInt();
    	    	            		
   	    	            		 if(sub_op == 5001){ // ficha documento/usurio
   	    	            			String S = canalEntrada.readUTF(); // recebe login
   	    	            			String Data_I = canalEntrada.readUTF();
   	    	            			String Data_F = canalEntrada.readUTF();
   		    	            			
   	    	            			
   	    	            			System.out.println("Data_Inicial Passada: "+ Data_I);
   	    	            			System.out.println("Data_Inicial Passada: "+ Data_F);
   	    	            			System.out.println("Login: "+ S);
   		    	            			
   		    	            			
   		    	            			// converter as datas para tipo date e depois desconverter antes de enviar para o usurio
   	    	            			System.out.println("OKKKKK");	
   	    	            			SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
   	    	                    
   	    	                     
   	    	                     
   	    	                  System.out.println("ERRO 111");
   	    	                     SimpleDateFormat sdf1 = new SimpleDateFormat("dd/MM/yyyy");
   	    	                     //System.out.println(sdf1.format(Data_Fim.getDate()));
   	    	                     //String Data_Fi = sdf1.format(Data_F); // string pega
   	    	                  System.out.println("ERRO 222");
   	    	                     Date DI = new Date();
   	    	                     Date DF = new Date();

   	    	                    
   	    	                         DI = (java.util.Date)sdf.parse(Data_I);
   	    	                      
   	    	                         DF = (java.util.Date)sdf1.parse(Data_F);
   	    	                     System.out.println("DI = "+ DI);
   	    	                  System.out.println("DF = "+ DF);
 		    	            	
   	    	            			            			 
	    	            			 
	    	            			
	    	            			    Connection con18 = null;
		    	            			
	    	            			    String get_password = new String();
		    	            			
		    	            			try {
		    	                        	
		    	                            Class.forName("com.mysql.jdbc.Driver");
		    	                          
		    	                            con18 = DriverManager.getConnection( "jdbc:mysql://localhost/modelagem_estatica?user=root&password=root" );
		    	                            
		    	                            String get_senha = "SELECT senha FROM dados WHERE login = '"+S+"';";
		    	                             
		    	                            Statement stm = con18.createStatement();  // para o banco dos users sockets
		    	                            ResultSet rsc = stm.executeQuery(get_senha); // banco users sockets
		    	                            
		    	                            
		    	                            while (rsc.next()) {
		    	                                get_password = rsc.getString("senha");
		    	                            	 } // while
		    	                            
		    	                            
		    	            			 } catch(ClassNotFoundException e) {
		    	            	                System.out.println("excesso Classe no encontrada");
		    	            	                e.printStackTrace();
		    	            	            } catch(SQLException e) {
		    	            	                System.out.println("SQL Exception... Erro na consulta:");
		    	            	                e.printStackTrace();
		    	            	            } finally {
		    	            	                try {
		    	            	                    con18.close();
		    	            	                    System.out.println("\n\nFechamendo a conexo");
		    	            	                } catch(SQLException erro) {
		    	            	                    System.out.println("Erro no fechamento");
		    	            	                    erro.printStackTrace();
		    	            	                }
		    	            	            }
	    	            			 
	    	            			 System.out.println("get_password: "+get_password);
	    	            			 canalSaida.writeUTF(get_password);
	    	            			 
	    	            			 try { 
	    	            			      SensorBaseClient client = new SensorBaseClient("http://localhost:9876/sensorbase/", S, get_password);
	    	            			      client.authenticate();
	    	            			      System.out.println("LOGADOO");
	    	            			       
	    	            			      
	    	            			    }
	    	            			    catch (SensorBaseClientException e) {
	    	            			      System.out.println("ERROR " + e.getMessage());
	    	            			    }
	    	            			 
	    	            			 
   	    	            			 
   	    	            			 
   	    	            		 }
   	    	            		 if(sub_op == 5002){
   	    	            			//cancelar
   	    	            		 }
			
	    	            		} // fim da sub_opcao == 500	
	    	            			
	    	            		
	    	            	} // fim do while true
	    	            	
	    	            	
	    	            } // fim do if z == 1
	    	            
	    	         	break;
	        			
	        		case 3: // sair do programa em geral	
	        			botao_sair = 1;
	        			
	        			
	        			
	        			break;
	        			
	        		case 4: // entrou no gerenciador de documentos 
	        		
	        		    break;
	        		    
	        		
	        		} // fim do switch
	        		
	        		if(botao_sair == 1){ // sai do programa geral
	        			break;
	        		}
	        		
	        	} // fim do while true
	        	
	        	 
	            
	            // encerra a conexao
	         
	            s.close( );
	         }
	            catch ( Exception e )
	            {
	               System.out.println( e );
	            }
		
	}

 }

